/* $Id: elm_globals.h,v 1.1.2.6 2004/08/15 17:26:27 hurtta Exp $ */

/*****************************************************************************
 *  The Elm (ME+) Mail System  -  $Revision: 1.1.2.6 $   $State: Exp $
 *
 *  Author: Kari Hurtta <hurtta+elm@posti.FMI.FI> 
 ******************************************************************************
 *  Based on Elm 2.4 hdrs/defs.h and hdrs/headers.h. 
 *  That code was following copyright:
 *
 *  The Elm Mail System 
 *
 * 			Copyright (c) 1988-1992 USENET Community Trust
 * 			Copyright (c) 1986,1987 Dave Taylor
 *****************************************************************************
 *  Based on Elm 2.5 hdrs/elm_globals.h. That code was following copyright:
 *
 *  The Elm Mail System
 *
 *                      Copyright (c) 1988-1995 USENET Community Trust
 * 			Copyright (c) 1986,1987 Dave Taylor
 *****************************************************************************/

/*
 * All source files in the Elm package should include this right
 * after "elm_defs.h".  This header should not be used by the
 * library or utility files.
 */

#define BACKSPACE	'\b'     	/* backspace character  */
#define TAB		'\t'            /* tab character        */
#define RETURN		'\r'     	/* carriage return char */
#define LINE_FEED	'\n'     	/* line feed character  */
#define ESCAPE		'\033'		/* the escape		*/

#define COMMA		','		/* comma character      */
                                        /* XXX  remove          */

#define SPACE		' '		/* space character      */
                                        /* XXX  remove          */

#define COLON		':'		/* the colon ..		*/
                                        /* XXX  remove          */

#define NO_OP_COMMAND	'\0'		/* no-op for timeouts   */
                                        /* XXX ? ? ? ?          */

#define STANDARD_INPUT  0		/* file number of stdin */
                                        /* XXX  remove          */

#define FORM		3		/*      <nevermind>        */
#define PREFORMATTED	4		/* forwarded form...       */

#define SAME_PAGE	1		/* redraw current only     */
#define NEW_PAGE	2		/* redraw message list     */
#define ILLEGAL_PAGE	0		/* error in page list, punt */

#define PAD		0		/* for printing name of    */
                                        /* XXX  remove             */
#define FULL		1		/*   the sort we're using  */
                                        /* XXX  remove             */


/* special cookies that may appear in the user's message text */

#define DONT_SAVE	"[no save]"
#define DONT_SAVE2	"[nosave]"

/* options to the copy_message() procedure */
#define CM_REMOVE_HEADER	(1<<0)	/* skip header of message */
#define CM_UPDATE_STATUS	(1<<2)	/* Update Status: Header  */
#define CM_REMAIL		(1<<4)	/* Add Sender: and Orig-To: headers */
#define CM_DECODE		(1<<5)	/* Decode MIME, PGP and elm */
#define CM_FILT_HDR		(1<<6)  /* Filter headers (for forwarding) */
#define CM_DISPLAYING		(1<<7)  /* Pass to MIME code */
#define CM_REMOVE_ENVELOPE	(1<<8)	/* Remove envelope */
#define CM_CRLF                 (1<<9)  /* Use CRLF */
#define CM_LF                   (1<<10)  /* Force CRLF -> LF */
#define CM_FORWARDING		(1<<11)	/* text is a message that we are     */
					/*   forwarding			     */
#define CM_ATTRIBUTION		(1<<12)	/* add attribution strings that	     */
					/*   format this as an included mssg */


#if  0           /* NOT USED --  */
#define CM_REMOTE		(1<<1)	/* append remote from hostname to    */
					/*   first line			     */
#define CM_MMDF_HEAD		(1<<3)	/* strip mmdf message seperator	     */

#define CM_FORWARDING		(1<<XX)	/* text is a message that we are     */
					/*   forwarding			     */
#define CM_ATTRIBUTION		(1<<XX)	/* add attribution strings that	     */
					/*   format this as an included mssg */

#endif

#if 0                 /* XXX not used yet */
/* options to the leave() procedure */
#define LEAVE_NORMAL		000	/* normal program termination	*/
#define LEAVE_ERROR		001	/* exit due to program error	*/
#define LEAVE_KEEP_EDITTMP	010	/* ...preserve composition file	*/
#define LEAVE_KEEP_TEMPFOLDER	020	/* ...preserve temp folder	*/
#define LEAVE_KEEP_LOCK		040	/* ...preserve folder locks	*/
#define LEAVE_EMERGENCY		071	/* emergency exit		*/
#define LEAVE_EXIT_STATUS(mode)	((mode) & 07)

#endif


#define UNDELETE	0		/* purely for ^U function... */
                                        /* XXX  remove          */

#if 0                 /* XXX not used yet */
/* options to the meta_match() procedure */
#define MATCH_TAG	0		/* tag matching entries		*/
#define MATCH_DELETE	1		/* delete matching entries	*/
#define MATCH_UNDELETE	2		/* undelete matching entries	*/
#endif

/****************************************************************************/

/* map character (e.g. 'A') to its control equivalent (e.g. '^A') */
#define ctrl(c)	        (((c) + '@') & 0x7f)

#if 0            /* XXX -- not used */
/* calculate next tabstop from position (col) */
/* leftmost col is zero, assumes 8-position tabstops */
#define tabstop(col)	(((col) & ~07) + 010)
#endif

/*    FIXME:               ....   remove these ... */
#define MAIN_HELP    0
#define OPTIONS_HELP 1
#define ALIAS_HELP   2
#define PAGER_HELP   3

#if 0                   /* softkeys not used */
#define MAIN	0
#define ALIAS   1
#define YESNO	2
#define CHANGE  3
#define READ	4
#endif


#define onoff(n)	(n == 0 ? "OFF" : "ON")

#define ClearLine(n)	MoveCursor(n,0); CleartoEOLN()
#define plural(n)	n == 1 ? "" : "s"

/** some months... **/

#define JANUARY		0			/* months of the year */
#define FEBRUARY	1
#define MARCH		2
#define APRIL		3
#define MAY		4
#define JUNE		5
#define JULY		6
#define AUGUST		7
#define SEPTEMBER	8
#define OCTOBER		9
#define NOVEMBER	10
#define DECEMBER	11


/** some defines for the 'userlevel' variable... **/

#define RANK_AMATEUR	0
#define AMATEUR		1
#define OKAY_AT_IT	2
#define GOOD_AT_IT	3
#define EXPERT		4
#define SUPER_AT_IT	5

/* Options for mail() procedure */
#define MAIL_COPY_MSG          (1<<0)
#define MAIL_EDIT_MSG          (1<<1)
#define MAIL_ISFORM            (1<<2)
#define MAIL_REPLYING          (1<<3)
#define MAIL_FORWARDING        (1<<4)
#define MAIL_HAVE_ATTACHMENTS  (1<<5)    /* Flag for verify transmission */
#define MAIL_HAVE_PGP_ENCODED  (1<<6)    /* Flag for verify transmission */
#define MAIL_MIME_ATTCH        (1<<7)    /* mimeforward */
#define MAIL_COPY_SELECTION    (1<<8)    /* canceled mail */
#define MAIL_DELETE_CANCEL     (1<<9)    /* And delete canceled_view mail also */


/*
 * "opmode" global - current operation mode settings.
 */

#define OPMODE_READ		010	/* running in folder read mode	*/
#define OPMODE_READ_NONEMPTY	011	/*  ...only read if non-empty	*/
#define OPMODE_SEND		020	/* running in send-only mode	*/
#define OPMODE_SEND_BATCH	021	/*  ...performing batch send	*/
#define OPMODE_CHECK_ONLY       040     /* check_only ... not on Elm 2.5 */

#define OPMODE_IS_READMODE(op)		(((op) & OPMODE_READ) != 0)
#define OPMODE_IS_SENDMODE(op)		(((op) & OPMODE_SEND) != 0)
#define OPMODE_IS_INTERACTIVE(op)	((op) != OPMODE_SEND_BATCH && \
					 (op) != OPMODE_CHECK_ONLY)


/******** global variables accessable by all pieces of the program *******/

EXTERN int inalias;		      /* TRUE if in the alias menu */
EXTERN int last_current     INIT(-1); /* previous current message */
EXTERN int last_header_page INIT(-1); /* last header page        */
EXTERN int headers_per_page;	      /* number of headers/page  */
EXTERN int original_umask;	      /* original umask, for restore before subshell */
EXTERN int sendmail_verbose;          /* Allow extended debugging on sendmail */
EXTERN int nucurr; 		      /* change list or just the current pointer  **/
EXTERN char cur_editfile[SLEN];       /* editor buffer */

EXTERN char batch_subject[SLEN];      /* subject buffer for batchmail */
EXTERN char included_file[SLEN];      /* name of file to place in edit buf */

EXTERN char version_buff[NLEN];       /* version buffer */

EXTERN char *def_ans_yes;	      /* default yes answer - single char, lc*/
EXTERN char *def_ans_no;	      /* default no answer - single char, lc */
EXTERN char *nls_deleted;	      /* [deleted] */
EXTERN char *nls_form;		      /* Form */
EXTERN char *nls_message;	      /* Message */
EXTERN char *nls_to;		      /* To */
EXTERN char *nls_from;		      /* From */
EXTERN char *nls_page;		      /* Page */
EXTERN char *change_word;	      /* change */
EXTERN char *save_word;		      /* save */
EXTERN char *copy_word;		      /* copy */
EXTERN char *cap_save_word;	      /* Save */
EXTERN char *cap_copy_word;	      /* Copy */
EXTERN char *saved_word;	      /* saved */
EXTERN char *copied_word;	      /* copied */

EXTERN int  write_elmrc;              /* flag: write elmrc in starting      */

EXTERN long size_of_pathfd;	      /** size of pathfile, 0 if none **/

EXTERN FILE *pathfd;		      /* path alias file          */
EXTERN FILE *domainfd;		      /* domains file 	    */

EXTERN int system_data INIT(-1);		/* fileno of system data file */
EXTERN int user_data   INIT(-1);		/* fileno of user data file   */

EXTERN JMP_BUF GetPromptBuf;		/* setjmp buffer */
EXTERN int InGetPrompt;		/* set if in GetPrompt() in read() */

#ifdef USE_PGP
EXTERN int pgp_status;
#endif

EXTERN int me_retcode;

EXTERN short mime_count; /* A counter used so that each call to
                         * mime_generate_boundary() returns a unique value.
                         */

/*
 * Local Variables:
 *  mode:c
 *  c-basic-offset:4
 *  buffer-file-coding-system: iso-8859-1
 * End:
 */




